#ifndef STATE_CLASSES_H
#define STATE_CLASSES_H

#include "State.h"

class StateContext;

//------------------------------------------------------------------------------
//
class StateImpl : public State
//
/// @brief Basic implementation of State interface giving default behaviour.
///
///
//------------------------------------------------------------------------------
{
public:

    StateImpl (StateContext &c, const char *n) : context (c), name (n) {}

    void Dark () {}
    void Light () {}
    void Movement () {}
    void NoMovement () {}
    void Timeout () {}

    const char * Name () const { return name; }

    StateContext &context;
    const char *name;
};

class Day : public StateImpl
{
public:
    Day (StateContext &c) : StateImpl (c, "Day") {}

    void Dark ();
};

class Night : public StateImpl
{
protected:
    Night (StateContext &c, const char *n) : StateImpl (c, n) {}
public:
    void Light ();
};

class Off : public Night
{
public:
    Off (StateContext &c) : Night (c, "Off") {}

    void Movement ();
};

class Moving : public Night
{
public:
    Moving (StateContext &c) : Night (c, "Moving") {}

    void NoMovement ();
};

class Timing : public Night
{
public:
    Timing (StateContext &c) : Night (c, "Timing") {}

    void Timeout ();
    void Movement ();
};

#endif // STATE_CLASSES_H
